<template>
  <div class="container">
    <h1>Список лиг</h1>
    <div class="search_content">
      <div class="search">
        <input
          type="text"
          class="search-field"
          placeholder="Введите имя лиги"
          v-model="search"
        />
        <img
          src="https://image.flaticon.com/icons/svg/49/49116.svg"
          alt=""
          class="search-icon"
        />
      </div>
      <br />
      <p>Выбирите сезон</p>
      <Seasons @seasonChanged="onSeasonChanged" :selectedSeason="season" />
      <hr />
      <ul>
        <li v-for="league in searchHandler" :key="league.id">
          <img :src="league.logo" alt="" />
          <router-link
            :to="{
              name: 'Fixtures',
              params: { id: league.id, season: season },
            }"
            >{{ league.name }}
          </router-link>
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import Seasons from "./Seasons.vue";
export default {
  components: { Seasons },
  data() {
    return {
      search: "",
      leagues: [],
      season: "",
      seasons: [],
      currentLeagues: [4, 2],
    };
  },
  mounted() {
    this.season = this.$route.params.season ? this.$route.params.season : 0;
    this.getLeagues();
    this.updateRoute();
  },
  methods: {
    getLeagues() {
      if (!this.season) {
        return;
      }

      const seasonSeg = `&season=${this.season}`;
      const url = `https://v3.football.api-sports.io/leagues?type=cup${seasonSeg}`;

      fetch(url, {
        method: "GET",
        headers: {
          "x-rapidapi-host": "v3.football.api-sports.io",
          "x-rapidapi-key": process.env.VUE_APP_API_KEY,
        },
      })
        .then((response) =>
          response.json().then((data) => {
            this.leagues = data.response
              .map((item) => item.league)
              .filter((it) => this.currentLeagues.includes(it.id));
          })
        )
        .catch((err) => {
          console.log(err);
        });
    },
    onSeasonChanged(event) {
      let params = this.$route.params;
      params["season"] = event;
      this.$router.push({ name: this.$route.name, params: params });

      this.season = event;
      this.getLeagues();
    },
    updateRoute() {
      let queryObj = {};
      let params = this.$route.params;

      if (this.search) {
        queryObj = { leagueName: this.search };
      }

      this.$router
        .push({ name: this.$route.name, params: params, query: queryObj })
        .catch(() => {});
    },
  },
  computed: {
    searchHandler() {
      this.updateRoute();
      return this.leagues.filter((elm) => {
        return elm.name.toLowerCase().includes(this.search);
      });
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Roboto");

* {
  margin: 0;
  padding: 0;
  outline: 0;
  font-family: "Roboto", sans-serif;
  text-align: center;
}

body {
  height: 100vh;
}

.container {
  position: relative;
  padding: 16px;
  top: 15%;
  left: 25%;
  width: 50%;
  background-color: #fafafa;
  text-align: center;
  border-radius: 4px;
  text-transform: uppercase;
  text-align: center;
}

.container h1 {
  margin-bottom: 50px;
}
.search {
  margin-bottom: 15px;
  display: inline-flex;
  border: 1px solid black;
  border-radius: 30px;
  padding: 10px;
  background-color: white;
}
.search-icon {
  width: 20px;
  height: 20px;
  margin-right: 10px;
  order: -1;
}

.search-field {
  width: 180px;
  border: 0;
}

.search-field:focus {
  outline: none;
}

.container ul {
  margin-top: 40px;
  list-style: none;
  text-transform: uppercase;
}
.container ul li img {
  height: 54px;
  width: 54px;
  align-items: center;
  margin-right: 10px;
}
.container p {
  text-transform: initial;
}
</style>
